// "Java Tech"
//  Code provided with book for educational purposes only.
//  No warranty or guarantee implied.
//  This code freely available. No copyright claimed.
//  2003
//

/*
 <applet code="MyRunnableApplet.class" width=300 height=300>
  </applet>
*/

/** Demo threading with Runnable implementation. **/
public class MyRunnableApplet extends java.applet.Applet
                              implements Runnable {

  /** Applet's start method creates a thread and lets it run for 2 secs.**/
  public void start () {

    // Create an instance of Thread with a
    // reference to this Runnable instance.
    Thread myThread = new Thread (this);

    // Start the thread
    myThread.start ();

  } // start

  /** Override the Runnable run() method. **/
  public void run() {
     int count = 0;

     while (true) {
        System.out.println ("Thread 2 alive");
        // Print every 0.10sec for 5 seconds
        try{
           Thread.sleep(100);
       } catch (InterruptedException e) {}
       count++;
       if ( count >= 50 ) break;
     }
     System.out.println ("Thread stopping");
  } // run

  public void paint(java.awt.Graphics g) {
    g.drawString("Thread demo 2", 20, 20);
  }

} // class MyRunnableApplet
